/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IMPRLOJA                                                 */
/* Tabela : IMPRESSORA POR LOJA                                               */
/*                                                                            */
/* Criao:                                                                   */
/* 30/01/2013 - LEONARDO MATOS                                                */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_IMPRLOJA'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
   DROP TRIGGER DTULTATU_IMPRLOJA
GO

CREATE TRIGGER DTULTATU_IMPRLOJA
ON IMPRLOJA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'IMPRLOJA', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDLOJA='+CDLOJA +';'+'NRSEQIMPRLOJA='+NRSEQIMPRLOJA +';',
                                                             CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE IMPRLOJA
      SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(IMPRLOJA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(IMPRLOJA.CDLOJA,0) = ISNULL(INSERTED.CDLOJA,0)) AND
            (ISNULL(IMPRLOJA.NRSEQIMPRLOJA,0) = ISNULL(INSERTED.NRSEQIMPRLOJA,0));
   END;
END;
GO

UPDATE IMPRLOJA SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATU' and
            type = 'D')
   ALTER TABLE IMPRLOJA DROP CONSTRAINT DEFAULT_DTULTATU
GO

ALTER TABLE IMPRLOJA ADD CONSTRAINT DEFAULT_DTULTATU
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_IMPRLOJA','5.50.000';
GO

