-- ============================================================
--   TABLE: PRATO
-- ============================================================

BEGIN
   BEGIN TRANSACTION T1;
      DECLARE @V_CDPAIPRATO VARCHAR(10);
      DECLARE @V_COUNT      NUMERIC = 0;		
      DECLARE @V_CDNVPRATO VARCHAR(1);
      DECLARE @V_CDPRATO VARCHAR(10);	
	
      DECLARE C_ATUPRATO CURSOR LOCAL FOR
	     SELECT 
	      CDNVPRATO, 
	   CDPRATO
        FROM 
          PRATO    
       OPEN C_ATUPRATO;
    
          FETCH NEXT FROM C_ATUPRATO 
          INTO @V_CDNVPRATO, @V_CDPRATO;
   
          WHILE (@@FETCH_STATUS = 0)BEGIN
	    /* BUSCANDO O PAI DO PRATO */
             SET @V_CDPAIPRATO = NULL; 
	     SELECT @V_CDPAIPRATO = CDPRATO           
	     FROM PRATO
	     WHERE CDNVPRATO = (@V_CDNVPRATO - 1)
		AND @V_CDPRATO LIKE CDPRATO+'%';
	                    
	     /* UPDATANDO O PAI DO PRATO */
	     UPDATE PRATO
	     SET CDPRATONIVANTE = @V_CDPAIPRATO
	     WHERE CDPRATO = @V_CDPRATO;
		  
	     SET @V_COUNT = @V_COUNT + 1;
	     IF @V_COUNT >= 5 BEGIN			 
	        SET @V_COUNT = 0;
	     END;
	      
	     FETCH NEXT FROM C_ATUPRATO
	     INTO @V_CDNVPRATO, @V_CDPRATO;
         END;
    
       CLOSE C_ATUPRATO;
    
    COMMIT TRANSACTION T1;
END;
GO

-- ============================================================
--   TRIGGER: PRATO_PAI
-- ============================================================

/*A Trigger tem o objetivo de atualizar o campo 'CDPRATONIVANTE'
para um prato que acabou de ser inserido*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'PRATO_PAI' AND
                 TYPE   = 'TR' 		        AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER PRATO_PAI
GO

CREATE TRIGGER PRATO_PAI
ON PRATO FOR INSERT
AS
DECLARE
   @V_CDPRATOPAI VARCHAR(10),
   @V_CDPRATO VARCHAR(10),
   @V_CDNVPRATO VARCHAR(1);
BEGIN 
  /*Caso o prato seja nvel '1', ele no possui nvel superior,
     por isso a varivel recebe valor nulo*/
     SELECT @V_CDPRATO = CDPRATO, @V_CDNVPRATO = CDNVPRATO 
     FROM INSERTED;
      
     IF @V_CDNVPRATO = '1'BEGIN
      SET @V_CDPRATOPAI = NULL;
   END ELSE BEGIN
      /*Seleo do cdigo do prato de nvel superior*/
      SELECT 
         @V_CDPRATOPAI = CDPRATO
      FROM 
         PRATO      
      WHERE 
         @V_CDPRATO LIKE PRATO.CDPRATO+'%' AND 
         (@V_CDNVPRATO - 1) = PRATO.CDNVPRATO;  
   END;
      /*Insero da varivel 'V_CDPRATOPAI' no campo que 
         recebe o cdigo do prato de nvel superior*/
      UPDATE PRATO
      SET CDPRATONIVANTE = @V_CDPRATOPAI
      FROM INSERTED
      WHERE ISNULL(PRATO.CDPRATO,'') = ISNULL(INSERTED.CDPRATO,'') AND
           ISNULL(PRATO.CDFILAUXPRAT,'') = ISNULL(INSERTED.CDFILAUXPRAT,'');
END;
GO
